"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _languageHandler = require("matrix-react-sdk/src/languageHandler");

require("../../../res/css/structures/ErrorView.scss");

/*
Copyright 2020 New Vector Ltd

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// directly import the style here as this layer does not support rethemedex at this time so no matrix-react-sdk
// scss variables will be accessible.
const CompatibilityView
/*: React.FC<IProps>*/
= ({
  onAccept
}) => {
  return /*#__PURE__*/React.createElement("div", {
    className: "mx_ErrorView"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mx_ErrorView_container"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_header"
  }, /*#__PURE__*/React.createElement("span", {
    className: "mx_HomePage_logo"
  }, /*#__PURE__*/React.createElement("img", {
    height: "42",
    src: "themes/riot/img/logos/riot-logo.svg",
    alt: "Riot"
  })), /*#__PURE__*/React.createElement("h1", null, (0, _languageHandler._t)("Unsupported browser"))), /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_col"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_row"
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h2", {
    id: "step1_heading"
  }, (0, _languageHandler._t)("Your browser can't run Riot")), /*#__PURE__*/React.createElement("p", null, (0, _languageHandler._t)("Riot uses advanced browser features which aren't supported by your current browser.")), /*#__PURE__*/React.createElement("p", null, (0, _languageHandler._t)('Please install <chromeLink>Chrome</chromeLink>, <firefoxLink>Firefox</firefoxLink>, ' + 'or <safariLink>Safari</safariLink> for the best experience.', {}, {
    'chromeLink': sub => /*#__PURE__*/React.createElement("a", {
      href: "https://www.google.com/chrome"
    }, sub),
    'firefoxLink': sub => /*#__PURE__*/React.createElement("a", {
      href: "https://firefox.com"
    }, sub),
    'safariLink': sub => /*#__PURE__*/React.createElement("a", {
      href: "https://apple.com/safari"
    }, sub)
  })), /*#__PURE__*/React.createElement("p", null, (0, _languageHandler._t)("You can continue using your current browser, but some or all features may not work " + "and the look and feel of the application may be incorrect.")), /*#__PURE__*/React.createElement("button", {
    onClick: onAccept
  }, (0, _languageHandler._t)("I understand the risks and wish to continue"))))), /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_col"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_row"
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h2", {
    id: "step2_heading"
  }, "Use Riot on mobile"), /*#__PURE__*/React.createElement("p", null, /*#__PURE__*/React.createElement("strong", null, "iOS"), " (iPhone or iPad)"), /*#__PURE__*/React.createElement("a", {
    href: "https://itunes.apple.com/app/riot-im/id1083446067?mt=8",
    target: "_blank",
    className: "mx_ClearDecoration"
  }, /*#__PURE__*/React.createElement("img", {
    height: "48",
    src: "themes/riot/img/download/apple.svg",
    alt: "Apple App Store"
  })), /*#__PURE__*/React.createElement("p", {
    className: "mx_Spacer"
  }, /*#__PURE__*/React.createElement("strong", null, "Android")), /*#__PURE__*/React.createElement("a", {
    href: "https://play.google.com/store/apps/details?id=im.vector.app",
    target: "_blank",
    className: "mx_ClearDecoration"
  }, /*#__PURE__*/React.createElement("img", {
    height: "48",
    src: "themes/riot/img/download/google.svg",
    alt: "Google Play Store"
  })), /*#__PURE__*/React.createElement("a", {
    href: "https://f-droid.org/repository/browse/?fdid=im.vector.alpha",
    target: "_blank",
    className: "mx_ClearDecoration"
  }, /*#__PURE__*/React.createElement("img", {
    height: "48",
    src: "themes/riot/img/download/fdroid.svg",
    alt: "F-Droid"
  }))))), /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_row mx_Center mx_Spacer"
  }, /*#__PURE__*/React.createElement("p", {
    className: "mx_Spacer"
  }, /*#__PURE__*/React.createElement("a", {
    href: "https://riot.im",
    target: "_blank",
    className: "mx_FooterLink"
  }, (0, _languageHandler._t)("Go to Riot.im"))))));
};

var _default = CompatibilityView;
exports.default = _default;