"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _languageHandler = require("matrix-react-sdk/src/languageHandler");

require("../../../res/css/structures/ErrorView.scss");

/*
Copyright 2020 New Vector Ltd

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// directly import the style here as this layer does not support rethemedex at this time so no matrix-react-sdk
// scss variables will be accessible.
const ErrorView
/*: React.FC<IProps>*/
= ({
  title,
  messages
}) => {
  return /*#__PURE__*/React.createElement("div", {
    className: "mx_ErrorView"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mx_ErrorView_container"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_header"
  }, /*#__PURE__*/React.createElement("span", {
    className: "mx_HomePage_logo"
  }, /*#__PURE__*/React.createElement("img", {
    height: "42",
    src: "themes/riot/img/logos/riot-logo.svg",
    alt: "Riot"
  })), /*#__PURE__*/React.createElement("h1", null, (0, _languageHandler._t)("Failed to start"))), /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_col"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_row"
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h2", {
    id: "step1_heading"
  }, title), messages && messages.map(msg => /*#__PURE__*/React.createElement("p", {
    key: msg
  }, msg))))), /*#__PURE__*/React.createElement("div", {
    className: "mx_HomePage_row mx_Center mx_Spacer"
  }, /*#__PURE__*/React.createElement("p", {
    className: "mx_Spacer"
  }, /*#__PURE__*/React.createElement("a", {
    href: "https://riot.im",
    target: "_blank",
    className: "mx_FooterLink"
  }, (0, _languageHandler._t)("Go to Riot.im"))))));
};

var _default = ErrorView;
exports.default = _default;