/*
Copyright 2016 OpenMarket Ltd
Copyright 2017 Vector Creations Ltd
Copyright 2019 New Vector Ltd

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
'use strict';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _EmbeddedPage = _interopRequireDefault(require("matrix-react-sdk/src/components/structures/EmbeddedPage"));

var _sanitizeHtml = _interopRequireDefault(require("sanitize-html"));

var _languageHandler = require("matrix-react-sdk/src/languageHandler");

class VectorEmbeddedPage extends _EmbeddedPage.default {
  // we're overriding the base component here, for Riot-specific tweaks
  translate(s) {
    s = (0, _sanitizeHtml.default)((0, _languageHandler._t)(s)); // ugly fix for https://github.com/vector-im/riot-web/issues/4243

    s = s.replace(/\[matrix\]/, '<a href="https://matrix.org" target="_blank" rel="noreferrer noopener"><img width="79" height="34" alt="[matrix]" style="padding-left: 1px;vertical-align: middle" src="welcome/images/matrix.svg"/></a>');
    return s;
  }

}

exports.default = VectorEmbeddedPage;
(0, _defineProperty2.default)(VectorEmbeddedPage, "replaces", 'EmbeddedPage');