"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _SdkConfig = _interopRequireDefault(require("matrix-react-sdk/src/SdkConfig"));

var _languageHandler = require("matrix-react-sdk/src/languageHandler");

/*
Copyright 2015, 2016 OpenMarket Ltd
Copyright 2019 New Vector Ltd

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
const VectorAuthFooter = () => {
  const brandingConfig = _SdkConfig.default.get().branding;

  let links = [{
    "text": "blog",
    "url": "https://blog.riot.im"
  }, {
    "text": "twitter",
    "url": "https://twitter.com/@RiotChat"
  }, {
    "text": "github",
    "url": "https://github.com/vector-im/riot-web"
  }];

  if (brandingConfig && brandingConfig.authFooterLinks) {
    links = brandingConfig.authFooterLinks;
  }

  const authFooterLinks = [];

  for (const linkEntry of links) {
    authFooterLinks.push( /*#__PURE__*/_react.default.createElement("a", {
      href: linkEntry.url,
      key: linkEntry.text,
      target: "_blank",
      rel: "noreferrer noopener"
    }, linkEntry.text));
  }

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "mx_AuthFooter"
  }, authFooterLinks, /*#__PURE__*/_react.default.createElement("a", {
    href: "https://matrix.org",
    target: "_blank",
    rel: "noreferrer noopener"
  }, (0, _languageHandler._t)('powered by Matrix')));
};

VectorAuthFooter.replaces = 'AuthFooter';
var _default = VectorAuthFooter;
exports.default = _default;