/*
Copyright 2015, 2016 OpenMarket Ltd
Copyright 2019 New Vector Ltd

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
'use strict';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _SdkConfig = _interopRequireDefault(require("matrix-react-sdk/src/SdkConfig"));

class VectorAuthHeaderLogo extends _react.default.PureComponent {
  render() {
    const brandingConfig = _SdkConfig.default.get().branding;

    let logoUrl = "themes/riot/img/logos/riot-im-logo-black-text.svg";

    if (brandingConfig && brandingConfig.authHeaderLogoUrl) {
      logoUrl = brandingConfig.authHeaderLogoUrl;
    }

    return /*#__PURE__*/_react.default.createElement("div", {
      className: "mx_AuthHeaderLogo"
    }, /*#__PURE__*/_react.default.createElement("img", {
      src: logoUrl,
      alt: "Riot"
    }));
  }

}

exports.default = VectorAuthHeaderLogo;
(0, _defineProperty2.default)(VectorAuthHeaderLogo, "replaces", 'AuthHeaderLogo');
(0, _defineProperty2.default)(VectorAuthHeaderLogo, "propTypes", {
  icon: _propTypes.default.string
});