import VectorBasePlatform from './VectorBasePlatform';
import BaseEventIndexManager from 'matrix-react-sdk/src/indexing/BaseEventIndexManager';
import { MatrixClient } from "matrix-js-sdk/src/client";
import { Room } from "matrix-js-sdk/src/models/room";
export default class ElectronPlatform extends VectorBasePlatform {
    private eventIndexManager;
    private pendingIpcCalls;
    private nextIpcCallId;
    private ssoID;
    constructor();
    getConfig(): Promise<{}>;
    onUpdateDownloaded: (ev: any, { releaseNotes, releaseName }: {
        releaseNotes: any;
        releaseName: any;
    }) => Promise<void>;
    getHumanReadableName(): string;
    setNotificationCount(count: number): void;
    supportsNotifications(): boolean;
    maySendNotifications(): boolean;
    displayNotification(title: string, msg: string, avatarUrl: string, room: Room): Notification;
    loudNotification(ev: Event, room: Object): void;
    getAppVersion(): Promise<string>;
    supportsAutoLaunch(): boolean;
    getAutoLaunchEnabled(): Promise<boolean>;
    setAutoLaunchEnabled(enabled: boolean): Promise<void>;
    supportsAutoHideMenuBar(): boolean;
    getAutoHideMenuBarEnabled(): Promise<boolean>;
    setAutoHideMenuBarEnabled(enabled: boolean): Promise<void>;
    supportsMinimizeToTray(): boolean;
    getMinimizeToTrayEnabled(): Promise<boolean>;
    setMinimizeToTrayEnabled(enabled: boolean): Promise<void>;
    canSelfUpdate(): Promise<boolean>;
    startUpdateCheck(): void;
    installUpdate(): void;
    getDefaultDeviceDisplayName(): string;
    screenCaptureErrorString(): string | null;
    requestNotificationPermission(): Promise<string>;
    reload(): void;
    _ipcCall(name: string, ...args: any[]): Promise<any>;
    _onIpcReply: (ev: any, payload: any) => void;
    getEventIndexingManager(): BaseEventIndexManager | null;
    setLanguage(preferredLangs: string[]): void;
    getSSOCallbackUrl(fragmentAfterLogin: string): URL;
    startSingleSignOn(mxClient: MatrixClient, loginType: "sso" | "cas", fragmentAfterLogin: string): void;
    _navigateForwardBack(back: boolean): void;
    onKeyDown(ev: KeyboardEvent): boolean;
    getPickleKey(userId: string, deviceId: string): Promise<string | null>;
    createPickleKey(userId: string, deviceId: string): Promise<string | null>;
    destroyPickleKey(userId: string, deviceId: string): Promise<void>;
}
