"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _VectorBasePlatform = _interopRequireDefault(require("./VectorBasePlatform"));

var _BasePlatform = require("matrix-react-sdk/src/BasePlatform");

var _BaseEventIndexManager = _interopRequireDefault(require("matrix-react-sdk/src/indexing/BaseEventIndexManager"));

var _dispatcher = _interopRequireDefault(require("matrix-react-sdk/src/dispatcher/dispatcher"));

var _languageHandler = require("matrix-react-sdk/src/languageHandler");

var rageshake = _interopRequireWildcard(require("matrix-react-sdk/src/rageshake/rageshake"));

var _Modal = _interopRequireDefault(require("matrix-react-sdk/src/Modal"));

var _InfoDialog = _interopRequireDefault(require("matrix-react-sdk/src/components/views/dialogs/InfoDialog"));

var _Spinner = _interopRequireDefault(require("matrix-react-sdk/src/components/views/elements/Spinner"));

var _KeyboardShortcuts = require("matrix-react-sdk/src/accessibility/KeyboardShortcuts");

var _Keyboard = require("matrix-react-sdk/src/Keyboard");

var _react = _interopRequireDefault(require("react"));

var _randomstring = require("matrix-js-sdk/src/randomstring");

var _actions = require("matrix-react-sdk/src/dispatcher/actions");

var _UpdateToast = require("matrix-react-sdk/src/toasts/UpdateToast");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const ipcRenderer = window.ipcRenderer;
const isMac = navigator.platform.toUpperCase().includes('MAC');

function platformFriendlyName()
/*: string*/
{
  // used to use window.process but the same info is available here
  if (navigator.userAgent.includes('Macintosh')) {
    return 'macOS';
  } else if (navigator.userAgent.includes('FreeBSD')) {
    return 'FreeBSD';
  } else if (navigator.userAgent.includes('OpenBSD')) {
    return 'OpenBSD';
  } else if (navigator.userAgent.includes('SunOS')) {
    return 'SunOS';
  } else if (navigator.userAgent.includes('Windows')) {
    return 'Windows';
  } else if (navigator.userAgent.includes('Linux')) {
    return 'Linux';
  } else {
    return 'Unknown';
  }
}

function _onAction(payload
/*: ActionPayload*/
) {
  // Whitelist payload actions, no point sending most across
  if (['call_state'].includes(payload.action)) {
    ipcRenderer.send('app_onAction', payload);
  }
}

function getUpdateCheckStatus(status
/*: boolean | string*/
) {
  if (status === true) {
    return {
      status: _BasePlatform.UpdateCheckStatus.Downloading
    };
  } else if (status === false) {
    return {
      status: _BasePlatform.UpdateCheckStatus.NotAvailable
    };
  } else {
    return {
      status: _BasePlatform.UpdateCheckStatus.Error,
      detail: status
    };
  }
}

class SeshatIndexManager extends _BaseEventIndexManager.default {
  constructor() {
    super();
    (0, _defineProperty2.default)(this, "pendingIpcCalls", {});
    (0, _defineProperty2.default)(this, "nextIpcCallId", 0);
    (0, _defineProperty2.default)(this, "_onIpcReply", (ev
    /*: {}*/
    , payload
    /*: IPCPayload*/
    ) => {
      if (payload.id === undefined) {
        console.warn("Ignoring IPC reply with no ID");
        return;
      }

      if (this.pendingIpcCalls[payload.id] === undefined) {
        console.warn("Unknown IPC payload ID: " + payload.id);
        return;
      }

      const callbacks = this.pendingIpcCalls[payload.id];
      delete this.pendingIpcCalls[payload.id];

      if (payload.error) {
        callbacks.reject(payload.error);
      } else {
        callbacks.resolve(payload.reply);
      }
    });
    ipcRenderer.on('seshatReply', this._onIpcReply);
  }

  async _ipcCall(name
  /*: string*/
  , ...args)
  /*: Promise<any>*/
  {
    // TODO this should be moved into the preload.js file.
    const ipcCallId = ++this.nextIpcCallId;
    return new Promise((resolve, reject) => {
      this.pendingIpcCalls[ipcCallId] = {
        resolve,
        reject
      };
      window.ipcRenderer.send('seshat', {
        id: ipcCallId,
        name,
        args
      });
    });
  }

  async supportsEventIndexing()
  /*: Promise<boolean>*/
  {
    return this._ipcCall('supportsEventIndexing');
  }

  async initEventIndex()
  /*: Promise<void>*/
  {
    return this._ipcCall('initEventIndex');
  }

  async addEventToIndex(ev
  /*: MatrixEvent*/
  , profile
  /*: MatrixProfile*/
  )
  /*: Promise<void>*/
  {
    return this._ipcCall('addEventToIndex', ev, profile);
  }

  async deleteEvent(eventId
  /*: string*/
  )
  /*: Promise<boolean>*/
  {
    return this._ipcCall('deleteEvent', eventId);
  }

  async isEventIndexEmpty()
  /*: Promise<boolean>*/
  {
    return this._ipcCall('isEventIndexEmpty');
  }

  async commitLiveEvents()
  /*: Promise<void>*/
  {
    return this._ipcCall('commitLiveEvents');
  }

  async searchEventIndex(searchConfig
  /*: SearchArgs*/
  )
  /*: Promise<SearchResult>*/
  {
    return this._ipcCall('searchEventIndex', searchConfig);
  }

  async addHistoricEvents(events
  /*: [EventAndProfile]*/
  , checkpoint
  /*: CrawlerCheckpoint | null*/
  , oldCheckpoint
  /*: CrawlerCheckpoint | null*/
  )
  /*: Promise<boolean>*/
  {
    return this._ipcCall('addHistoricEvents', events, checkpoint, oldCheckpoint);
  }

  async addCrawlerCheckpoint(checkpoint
  /*: CrawlerCheckpoint*/
  )
  /*: Promise<void>*/
  {
    return this._ipcCall('addCrawlerCheckpoint', checkpoint);
  }

  async removeCrawlerCheckpoint(checkpoint
  /*: CrawlerCheckpoint*/
  )
  /*: Promise<void>*/
  {
    return this._ipcCall('removeCrawlerCheckpoint', checkpoint);
  }

  async loadFileEvents(args)
  /*: Promise<[EventAndProfile]>*/
  {
    return this._ipcCall('loadFileEvents', args);
  }

  async loadCheckpoints()
  /*: Promise<[CrawlerCheckpoint]>*/
  {
    return this._ipcCall('loadCheckpoints');
  }

  async closeEventIndex()
  /*: Promise<void>*/
  {
    return this._ipcCall('closeEventIndex');
  }

  async getStats()
  /*: Promise<IndexStats>*/
  {
    return this._ipcCall('getStats');
  }

  async deleteEventIndex()
  /*: Promise<void>*/
  {
    return this._ipcCall('deleteEventIndex');
  }

}

class ElectronPlatform extends _VectorBasePlatform.default {
  // this is the opaque token we pass to the HS which when we get it in our callback we can resolve to a profile
  constructor() {
    super();
    (0, _defineProperty2.default)(this, "eventIndexManager", new SeshatIndexManager());
    (0, _defineProperty2.default)(this, "pendingIpcCalls", {});
    (0, _defineProperty2.default)(this, "nextIpcCallId", 0);
    (0, _defineProperty2.default)(this, "ssoID", (0, _randomstring.randomString)(32));

    _dispatcher.default.register(_onAction);
    /*
        IPC Call `check_updates` returns:
        true if there is an update available
        false if there is not
        or the error if one is encountered
     */


    ipcRenderer.on('check_updates', (event, status) => {
      _dispatcher.default.dispatch(_objectSpread({
        action: _actions.Action.CheckUpdates
      }, getUpdateCheckStatus(status)));
    }); // try to flush the rageshake logs to indexeddb before quit.

    ipcRenderer.on('before-quit', function () {
      console.log('riot-desktop closing');
      rageshake.flush();
    });
    ipcRenderer.on('ipcReply', this._onIpcReply.bind(this));
    ipcRenderer.on('update-downloaded', this.onUpdateDownloaded.bind(this));
    ipcRenderer.on('preferences', () => {
      _dispatcher.default.fire(_actions.Action.ViewUserSettings);
    }); // register OS-specific shortcuts

    if (isMac) {
      (0, _KeyboardShortcuts.registerShortcut)(_KeyboardShortcuts.Categories.NAVIGATION, {
        keybinds: [{
          modifiers: [_KeyboardShortcuts.Modifiers.COMMAND],
          key: _Keyboard.Key.COMMA
        }],
        description: (0, _languageHandler._td)("Open user settings")
      });
      (0, _KeyboardShortcuts.registerShortcut)(_KeyboardShortcuts.Categories.NAVIGATION, {
        keybinds: [{
          modifiers: [_KeyboardShortcuts.Modifiers.COMMAND],
          key: _Keyboard.Key.SQUARE_BRACKET_LEFT
        }, {
          modifiers: [_KeyboardShortcuts.Modifiers.COMMAND],
          key: _Keyboard.Key.SQUARE_BRACKET_RIGHT
        }],
        description: (0, _languageHandler._td)("Previous/next recently visited room or community")
      });
    } else {
      (0, _KeyboardShortcuts.registerShortcut)(_KeyboardShortcuts.Categories.NAVIGATION, {
        keybinds: [{
          modifiers: [_KeyboardShortcuts.Modifiers.ALT],
          key: _Keyboard.Key.ARROW_LEFT
        }, {
          modifiers: [_KeyboardShortcuts.Modifiers.ALT],
          key: _Keyboard.Key.ARROW_RIGHT
        }],
        description: (0, _languageHandler._td)("Previous/next recently visited room or community")
      });
    }

    this._ipcCall("startSSOFlow", this.ssoID);
  }

  async getConfig()
  /*: Promise<{}>*/
  {
    return this._ipcCall('getConfig');
  }

  async onUpdateDownloaded(ev, {
    releaseNotes,
    releaseName
  }) {
    if (this.shouldShowUpdate(releaseName)) {
      (0, _UpdateToast.showToast)(await this.getAppVersion(), releaseName, releaseNotes);
    }
  }

  getHumanReadableName()
  /*: string*/
  {
    return 'Electron Platform'; // no translation required: only used for analytics
  }

  setNotificationCount(count
  /*: number*/
  ) {
    if (this.notificationCount === count) return;
    super.setNotificationCount(count);
    ipcRenderer.send('setBadgeCount', count);
  }

  supportsNotifications()
  /*: boolean*/
  {
    return true;
  }

  maySendNotifications()
  /*: boolean*/
  {
    return true;
  }

  displayNotification(title
  /*: string*/
  , msg
  /*: string*/
  , avatarUrl
  /*: string*/
  , room
  /*: Room*/
  )
  /*: Notification*/
  {
    // GNOME notification spec parses HTML tags for styling...
    // Electron Docs state all supported linux notification systems follow this markup spec
    // https://github.com/electron/electron/blob/master/docs/tutorial/desktop-environment-integration.md#linux
    // maybe we should pass basic styling (italics, bold, underline) through from MD
    // we only have to strip out < and > as the spec doesn't include anything about things like &amp;
    // so we shouldn't assume that all implementations will treat those properly. Very basic tag parsing is done.
    if (navigator.userAgent.includes('Linux')) {
      msg = msg.replace(/</g, '&lt;').replace(/>/g, '&gt;');
    } // Notifications in Electron use the HTML5 notification API


    const notifBody = {
      body: msg,
      silent: true // we play our own sounds

    };
    if (avatarUrl) notifBody['icon'] = avatarUrl;
    const notification = new window.Notification(title, notifBody);

    notification.onclick = () => {
      _dispatcher.default.dispatch({
        action: 'view_room',
        room_id: room.roomId
      });

      window.focus();

      this._ipcCall('focusWindow');
    };

    return notification;
  }

  loudNotification(ev
  /*: Event*/
  , room
  /*: Object*/
  ) {
    ipcRenderer.send('loudNotification');
  }

  clearNotification(notif
  /*: Notification*/
  ) {
    notif.close();
  }

  async getAppVersion()
  /*: Promise<string>*/
  {
    return this._ipcCall('getAppVersion');
  }

  supportsAutoLaunch()
  /*: boolean*/
  {
    return true;
  }

  async getAutoLaunchEnabled()
  /*: Promise<boolean>*/
  {
    return this._ipcCall('getAutoLaunchEnabled');
  }

  async setAutoLaunchEnabled(enabled
  /*: boolean*/
  )
  /*: Promise<void>*/
  {
    return this._ipcCall('setAutoLaunchEnabled', enabled);
  }

  supportsAutoHideMenuBar()
  /*: boolean*/
  {
    // This is irelevant on Mac as Menu bars don't live in the app window
    return !isMac;
  }

  async getAutoHideMenuBarEnabled()
  /*: Promise<boolean>*/
  {
    return this._ipcCall('getAutoHideMenuBarEnabled');
  }

  async setAutoHideMenuBarEnabled(enabled
  /*: boolean*/
  )
  /*: Promise<void>*/
  {
    return this._ipcCall('setAutoHideMenuBarEnabled', enabled);
  }

  supportsMinimizeToTray()
  /*: boolean*/
  {
    // Things other than Mac support tray icons
    return !isMac;
  }

  async getMinimizeToTrayEnabled()
  /*: Promise<boolean>*/
  {
    return this._ipcCall('getMinimizeToTrayEnabled');
  }

  async setMinimizeToTrayEnabled(enabled
  /*: boolean*/
  )
  /*: Promise<void>*/
  {
    return this._ipcCall('setMinimizeToTrayEnabled', enabled);
  }

  async canSelfUpdate()
  /*: Promise<boolean>*/
  {
    const feedUrl = await this._ipcCall('getUpdateFeedUrl');
    return Boolean(feedUrl);
  }

  startUpdateCheck() {
    super.startUpdateCheck();
    ipcRenderer.send('check_updates');
  }

  installUpdate() {
    // IPC to the main process to install the update, since quitAndInstall
    // doesn't fire the before-quit event so the main process needs to know
    // it should exit.
    ipcRenderer.send('install_update');
  }

  getDefaultDeviceDisplayName()
  /*: string*/
  {
    return (0, _languageHandler._t)('Riot Desktop (%(platformName)s)', {
      platformName: platformFriendlyName()
    });
  }

  screenCaptureErrorString()
  /*: string | null*/
  {
    return null;
  }

  requestNotificationPermission()
  /*: Promise<string>*/
  {
    return Promise.resolve('granted');
  }

  reload() {
    // we used to remote to the main process to get it to
    // reload the webcontents, but in practice this is unnecessary:
    // the normal way works fine.
    window.location.reload(false);
  }

  async _ipcCall(name
  /*: string*/
  , ...args)
  /*: Promise<any>*/
  {
    const ipcCallId = ++this.nextIpcCallId;
    return new Promise((resolve, reject) => {
      this.pendingIpcCalls[ipcCallId] = {
        resolve,
        reject
      };
      window.ipcRenderer.send('ipcCall', {
        id: ipcCallId,
        name,
        args
      }); // Maybe add a timeout to these? Probably not necessary.
    });
  }

  _onIpcReply(ev, payload) {
    if (payload.id === undefined) {
      console.warn("Ignoring IPC reply with no ID");
      return;
    }

    if (this.pendingIpcCalls[payload.id] === undefined) {
      console.warn("Unknown IPC payload ID: " + payload.id);
      return;
    }

    const callbacks = this.pendingIpcCalls[payload.id];
    delete this.pendingIpcCalls[payload.id];

    if (payload.error) {
      callbacks.reject(payload.error);
    } else {
      callbacks.resolve(payload.reply);
    }
  }

  getEventIndexingManager()
  /*: BaseEventIndexManager | null*/
  {
    return this.eventIndexManager;
  }

  setLanguage(preferredLangs
  /*: string[]*/
  ) {
    this._ipcCall('setLanguage', preferredLangs).catch(error => {
      console.log("Failed to send setLanguage IPC to Electron");
      console.error(error);
    });
  }

  getSSOCallbackUrl(hsUrl
  /*: string*/
  , isUrl
  /*: string*/
  , fragmentAfterLogin
  /*: string*/
  )
  /*: URL*/
  {
    const url = super.getSSOCallbackUrl(hsUrl, isUrl, fragmentAfterLogin);
    url.protocol = "riot";
    url.searchParams.set("riot-desktop-ssoid", this.ssoID);
    return url;
  }

  startSingleSignOn(mxClient
  /*: MatrixClient*/
  , loginType
  /*: "sso" | "cas"*/
  , fragmentAfterLogin
  /*: string*/
  ) {
    // this will get intercepted by electron-main will-navigate
    super.startSingleSignOn(mxClient, loginType, fragmentAfterLogin);

    _Modal.default.createTrackedDialog('Electron', 'SSO', _InfoDialog.default, {
      title: (0, _languageHandler._t)("Go to your browser to complete Sign In"),
      description: /*#__PURE__*/_react.default.createElement(_Spinner.default, null)
    });
  }

  _navigateForwardBack(back
  /*: boolean*/
  ) {
    this._ipcCall(back ? "navigateBack" : "navigateForward");
  }

  onKeyDown(ev
  /*: KeyboardEvent*/
  )
  /*: boolean*/
  {
    let handled = false;

    switch (ev.key) {
      case _Keyboard.Key.SQUARE_BRACKET_LEFT:
      case _Keyboard.Key.SQUARE_BRACKET_RIGHT:
        if (isMac && ev.metaKey && !ev.altKey && !ev.ctrlKey && !ev.shiftKey) {
          this._navigateForwardBack(ev.key === _Keyboard.Key.SQUARE_BRACKET_LEFT);

          handled = true;
        }

        break;

      case _Keyboard.Key.ARROW_LEFT:
      case _Keyboard.Key.ARROW_RIGHT:
        if (!isMac && ev.altKey && !ev.metaKey && !ev.ctrlKey && !ev.shiftKey) {
          this._navigateForwardBack(ev.key === _Keyboard.Key.ARROW_LEFT);

          handled = true;
        }

        break;
    }

    return handled;
  }

}

exports.default = ElectronPlatform;