import BasePlatform from 'matrix-react-sdk/src/BasePlatform';
import Favicon from "../../favicon";
/**
 * Vector-specific extensions to the BasePlatform template
 */
export default abstract class VectorBasePlatform extends BasePlatform {
    protected _favicon: Favicon;
    getConfig(): Promise<{}>;
    getHumanReadableName(): string;
    /**
     * Delay creating the `Favicon` instance until first use (on the first notification) as
     * it uses canvas, which can trigger a permission prompt in Firefox's resist fingerprinting mode.
     * See https://github.com/vector-im/riot-web/issues/9605.
     */
    get favicon(): Favicon;
    _updateFavicon(): void;
    setNotificationCount(count: number): void;
    setErrorStatus(errorDidOccur: boolean): void;
    /**
     * Begin update polling, if applicable
     */
    startUpdater(): void;
    /**
     * Get a sensible default display name for the
     * device Vector is running on
     */
    getDefaultDeviceDisplayName(): string;
}
