import VectorBasePlatform from './VectorBasePlatform';
import { UpdateCheckStatus } from "matrix-react-sdk/src/BasePlatform";
import { Room } from "matrix-js-sdk/src/models/room";
export default class WebPlatform extends VectorBasePlatform {
    private runningVersion;
    getHumanReadableName(): string;
    /**
     * Returns true if the platform supports displaying
     * notifications, otherwise false.
     */
    supportsNotifications(): boolean;
    /**
     * Returns true if the application currently has permission
     * to display notifications. Otherwise false.
     */
    maySendNotifications(): boolean;
    /**
     * Requests permission to send notifications. Returns
     * a promise that is resolved when the user has responded
     * to the request. The promise has a single string argument
     * that is 'granted' if the user allowed the request or
     * 'denied' otherwise.
     */
    requestNotificationPermission(): Promise<string>;
    displayNotification(title: string, msg: string, avatarUrl: string, room: Room): void;
    _getVersion(): Promise<string>;
    getAppVersion(): Promise<string>;
    startUpdater(): void;
    canSelfUpdate(): Promise<boolean>;
    pollForUpdate: () => Promise<{
        status: UpdateCheckStatus;
    } | {
        status: UpdateCheckStatus;
        detail: any;
    }>;
    startUpdateCheck(): void;
    installUpdate(): void;
    getDefaultDeviceDisplayName(): string;
    screenCaptureErrorString(): string | null;
    reload(): void;
}
